#!/usr/bin/perl

my $count = 30;
my $period = 1000000;
my $host = "localhost";
my $port = 8005;
my $proxy = 8006;
my $unproxy = "/tmp/tesla-test-socket";

my $avg = q!perl -ane '++$c; $t[$_] += $F[$_] foreach(0..$#F); END { print join("\t",map { $_/($c||1) } @t),"\n" }'!;
my $pref = q!perl -ape 'print join("\t",@ARGV,@_)'!;

sub sys {
    print "SYSTEM: $_[0]\n";
    system $_[0];
}

my $line;
sub out {
    $line = join("\t", @_);
#    open(OUT, ">>results") || die;
#    print OUT $line;
#    close OUT;
}

sub run {
    sys "$_[0] &";
    sleep 1;
}

sub test {
    sys qq!time.pm result.time1 $_[0] | perl -ane 'print join("\\t",qw($line),\$_)' >> results!;
    sleep 1;
}

sub calc {
    my $cnt = shift;

    my @totals = ();

    foreach my $i (1..$cnt) {
	open(IN, "<result.time$i");
	chomp(my $in = <IN>);
	my @l = split(/\s+/, $in);
	$totals[$_] += $l[$_] foreach (0..$#l);
	close(IN);
    }

    open(OUT, ">>results.time");
    print OUT "$line",join("\t", @totals),"\n";
    close(OUT);
}

unlink "results" || die;
unlink "results.time" || die;

foreach my $bl ("l") {
    my $bwlt = $bl eq "b" ? "bandwidth" : "latency";

    foreach my $chunk (1,16,256,4096,16384,65536) {
	next if ($bl eq "l" && $chunk > 1);

#    foreach my $chunk (4096) {
	out "r${bl}",$chunk,"";
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "test/r$bwlt $host $port $count $chunk $period";
	calc 1;

	out "r${bl}dummy",$chunk,"";
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "tesla +dummy test/r$bwlt $host $port $count $chunk $period";
	calc 1;

	out "r${bl}proxy",$chunk,"";
	run "time.pm result.time2 test/proxy $proxy localhost $port" , 1;
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "test/r$bwlt $host $proxy $count $chunk $period";
	calc 2;

	out "r${bl}unproxy",$chunk,"";
	run "time.pm result.time2 test/proxy $unproxy localhost $port" , 1;
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "test/r$bwlt $host $unproxy $count $chunk $period";
	calc 2;

	out "r${bl}des",$chunk,"";
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "test/des-r$bwlt $host $port $count $chunk $period";
	calc 1;

	out "r${bl}crypt",$chunk,"";
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "tesla +crypt test/r$bwlt $host $port $count $chunk $period";
	calc 1;

	out "r${bl}desproxy",$chunk,"";
	run "time.pm result.time2 test/des-proxy $proxy localhost $port" , 1;
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "test/r$bwlt $host $proxy $count $chunk $period";
	calc 2;

	out "r${bl}desunproxy",$chunk,"";
	run "time.pm result.time2 test/des-proxy $unproxy localhost $port" , 1;
	run "test/w$bwlt $port 0 $chunk" , 1;
	test "test/r$bwlt $host $unproxy $count $chunk $period";
	calc 2;
    }
}
